## iddawc 1.1.9+ds

=== CMakeLists.txt ===
#
# Iddawc library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2019-2023 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(iddawc C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(IDDAWC_LIBS )

set(PROJECT_DESCRIPTION "OAuth2/OIDC Client and RP library")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/iddawc/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "1")
set(LIBRARY_VERSION_PATCH "9")
set(ORCANIA_VERSION_REQUIRED "2.3.3")
set(YDER_VERSION_REQUIRED "1.4.20")
set(ULFIUS_VERSION_REQUIRED "2.7.15")
set(RHONABWY_VERSION_REQUIRED "1.1.13")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(I_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${I_CMAKE_MODULE_PATH}")

set(IDWCC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/idwcc)

include(GNUInstallDirs)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/iddawc.h # allow many IDEs to find and edit it
        ${SRC_DIR}/iddawc.c)

set(PKGCONF_REQ "")
set(PKGCONF_REQ_PRIVATE "")

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
list(APPEND IDDAWC_LIBS Jansson::Jansson)

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
list(APPEND IDDAWC_LIBS GnuTLS::GnuTLS)

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(iddawc_static STATIC ${LIB_SRC})
    add_library(Iddawc::Iddawc-static ALIAS iddawc_static)
    target_include_directories(iddawc_static
        PUBLIC "$<BUILD_INTERFACE:${INC_DIR}>"
        PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
        PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
    target_link_libraries(iddawc_static PUBLIC ${IDDAWC_LIBS})
    target_compile_definitions(iddawc_static PUBLIC O_STATIC_LIBRARY)
    set_target_properties(iddawc_static PROPERTIES
            PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
            OUTPUT_NAME iddawc
            EXPORT_NAME Iddawc-static)
    if (MSVC)
        set_target_properties(iddawc_static PROPERTIES
                OUTPUT_NAME iddawc-static)
    endif ()
    if (NOT MSVC)
        target_compile_options(iddawc_static PRIVATE -Wextra -Wconversion)
    endif ()
    set(iddawc_lib iddawc_static)
endif ()

# shared library

add_library(iddawc SHARED ${LIB_SRC})
add_library(Iddawc::Iddawc ALIAS iddawc)
target_include_directories(iddawc
    PUBLIC "$<BUILD_INTERFACE:${INC_DIR}>"
    PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
    PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
target_link_libraries(iddawc PUBLIC ${IDDAWC_LIBS})
set_target_properties(iddawc PROPERTIES
        PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}"
        WINDOWS_EXPORT_ALL_SYMBOLS TRUE
        EXPORT_NAME Iddawc)
if (WIN32)
    set_target_properties(iddawc PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()
if (NOT MSVC)
    target_compile_options(iddawc PRIVATE -Wextra -Wconversion)
endif()
set(iddawc_lib iddawc)

find_package(Orcania ${ORCANIA_VERSION_REQUIRED} REQUIRED)
if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
    message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
endif ()

target_link_libraries(iddawc PUBLIC $<TARGET_NAME:Orcania::Orcania>)
if (BUILD_STATIC)
    if(TARGET Orcania::Orcania-static)
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Orcania::Orcania-static>)
    else()
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Orcania::Orcania>)
    endif()
endif ()

find_package(Yder ${YDER_VERSION_REQUIRED} REQUIRED)
if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
    message(STATUS "Yder found: ${YDER_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
endif ()

target_link_libraries(iddawc PUBLIC $<TARGET_NAME:Yder::Yder>)
if (BUILD_STATIC)
    if(TARGET Yder::Yder-static)
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Yder::Yder-static>)
    else()
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Yder::Yder>)
    endif()
endif ()

find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} REQUIRED)
if ("${ULFIUS_VERSION_STRING}" VERSION_GREATER_EQUAL "${ULFIUS_VERSION_REQUIRED}")
    message(STATUS "Ulfius found: ${ULFIUS_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Ulfius version required: ${ULFIUS_VERSION_REQUIRED} - version installed: ${ULFIUS_VERSION_STRING}")
endif ()

target_link_libraries(iddawc PUBLIC $<TARGET_NAME:Ulfius::Ulfius>)
if (BUILD_STATIC)
    if(TARGET Ulfius::Ulfius-static)
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Ulfius::Ulfius-static>)
    else()
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Ulfius::Ulfius>)
    endif()
endif ()

find_package(Rhonabwy ${RHONABWY_VERSION_REQUIRED} REQUIRED)
if ("${RHONABWY_VERSION_STRING}" VERSION_GREATER_EQUAL "${RHONABWY_VERSION_REQUIRED}")
    message(STATUS "Rhonabwy found: ${RHONABWY_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Rhonabwy version required: ${RHONABWY_VERSION_REQUIRED} - version installed: ${RHONABWY_VERSION_STRING}")
endif ()

target_link_libraries(iddawc PUBLIC $<TARGET_NAME:Rhonabwy::Rhonabwy>)
if (BUILD_STATIC)
    if(TARGET Rhonabwy::Rhonabwy-static)
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Rhonabwy::Rhonabwy-static>)
    else()
        target_link_libraries(iddawc_static PUBLIC $<TARGET_NAME:Rhonabwy::Rhonabwy>)
    endif()
endif ()

# build idwcc

option(BUILD_IDWCC "Build idwcc application." OFF)

if (BUILD_IDWCC)
    find_package(Threads REQUIRED)
    list(APPEND IDDAWC_LIBS ${CMAKE_THREAD_LIBS_INIT})
    include(FindZLIB)
    find_package(ZLIB REQUIRED)
    if (ZLIB_FOUND)
      list(APPEND IDDAWC_LIBS ${ZLIB_LIBRARIES})
      include_directories(${ZLIB_INCLUDE_DIRS})
    endif ()
    add_executable(idwcc ${IDWCC_DIR}/idwcc.c
                         ${INC_DIR}/iddawc.h
                         ${IDWCC_DIR}/http_compression_callback.c
                         ${IDWCC_DIR}/http_compression_callback.h
                         ${IDWCC_DIR}/static_compressed_inmemory_website_callback.c
                         ${IDWCC_DIR}/static_compressed_inmemory_website_callback.h
                         ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
    set_target_properties(idwcc PROPERTIES SKIP_BUILD_RPATH TRUE COMPILE_OPTIONS "-Wextra;-Wconversion")
    add_dependencies(idwcc iddawc)
    target_link_libraries(idwcc iddawc ${IDDAWC_LIBS})
    install(TARGETS idwcc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES ${IDWCC_DIR}/idwcc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
    install(DIRECTORY ${IDWCC_DIR}/webapp/ DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/idwcc/webapp/ COMPONENT runtime)
endif ()

# documentation

option(BUILD_IDDAWC_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_IDDAWC_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)

        configure_file(${doxyfile_in} ${doxyfile} @ONLY)

        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# build iddawc-cfg.h file
configure_file(${INC_DIR}/iddawc-cfg.h.in ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# tests

option(BUILD_IDDAWC_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)

if (BUILD_IDDAWC_TESTING)
    find_package(Check REQUIRED)
    if (CHECK_FOUND)
        if (NOT WIN32 AND NOT APPLE)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TEST_LIBS )

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        list(APPEND TEST_LIBS Check::Check)
        list(APPEND TEST_LIBS Iddawc::Iddawc)
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            list(APPEND TEST_LIBS ${CMAKE_THREAD_LIBS_INIT} m)
        endif ()
        if (NOT APPLE AND NOT WIN32)
            list(APPEND TEST_LIBS rt)
        endif ()
        if (NOT WIN32 AND NOT APPLE)
            list(APPEND TEST_LIBS Subunit::Subunit)
        endif ()

        set(TESTS
            core
            implicit
            id_token
            token
            load_config
            load_userinfo
            flow
            introspection
            revocation
            registration
            dpop
            api_request
            device
            par
            ciba
            session
            rar
        )

        configure_file(
                "${I_CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PRIVATE ${TST_DIR})
            target_link_libraries(${t} PRIVATE ${TEST_LIBS})
            add_test(NAME ${t}
                     WORKING_DIRECTORY ${TST_DIR}

=== examples/Makefile ===
#
# Iddawc library
#
# Makefile used to build the example files
#
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# License MIT
#

IDDAWC_INCLUDE=../include
IDDAWC_LOCATION=../src
IDDAWC_LIBRARY=$(IDDAWC_LOCATION)/libiddawc.so
CC=gcc
CFLAGS+=-Wall -D_REENTRANT -I$(IDDAWC_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
LDFLAGS=-lc -liddawc -ljansson -L$(IDDAWC_LOCATION) -lyder -lorcania
TARGET=github_example gitlab_example glewlwyd_oidc_id_token_code google_example microsoft_example facebook_example token_introspection token_revocation client_registration

all: $(TARGET)

clean:
	rm -f *.o $(TARGET)

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%: $(IDDAWC_LIBRARY) %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

run_%: %
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION):$(LD_LIBRARY_PATH) ./$^

=== src/Makefile ===
#
# Iddawc Library
#
# Makefile used to build the software
#
# Copyright 2019-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=iddawc
PROJECT_DESCRIPTION=OAuth2-OIDC client library
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/iddawc/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
IDDAWC_INCLUDE=../include
PKGCONFIG_FILE=../libiddawc.pc
PKGCONFIG_TEMPLATE=../libiddawc.pc.in
CONFIG_FILE=$(IDDAWC_INCLUDE)/iddawc-cfg.h
CONFIG_TEMPLATE=$(IDDAWC_INCLUDE)/iddawc-cfg.h.in
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -Wconversion -D_REENTRANT -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc -lulfius -lyder -lorcania -lrhonabwy -lgnutls -ljansson $(LDFLAGS)
SONAME=-soname
OBJECTS=iddawc.o
OUTPUT=libiddawc.so
VERSION_MAJOR=1
VERSION_MINOR=1
VERSION_PATCH=9

.PHONY: all clean

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

target: $(OBJECTS)

%.o: %.c $(CONFIG_FILE) $(IDDAWC_INCLUDE)/iddawc.h
	$(CC) $(CFLAGS) $<

libiddawc.so: $(CONFIG_FILE) $(PKGCONFIG_FILE) $(OBJECTS)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LYDER) $(LJANSSON) $(LCURL) $(LGNUTLS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE) $(CONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(IDDAWC_INCLUDE)/iddawc.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libiddawc.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/iddawc.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libiddawc.so

release: ADDITIONALFLAGS=-O3

release: libiddawc.so

=== test/Makefile ===
#
# Iddawc library
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk.
#

IDDAWC_INCLUDE=../include
IDDAWC_LOCATION=../src
IDDAWC_LIBRARY=$(IDDAWC_LOCATION)/libiddawc.so
CC=gcc
CFLAGS+=-Wall -D_REENTRANT -I$(IDDAWC_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
LDFLAGS=-lc -liddawc -L$(IDDAWC_LOCATION) $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs librhonabwy) $(shell pkg-config --libs jansson) $(shell pkg-config --libs check) $(shell pkg-config --libs gnutls)
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
TARGET=core implicit id_token token load_config load_userinfo flow introspection revocation registration dpop api_request device par ciba session rar
TARGET_TEST=test_core test_implicit test_id_token test_token test_load_config test_load_userinfo test_flow test_introspection test_revocation test_registration test_dpop test_api_request test_device test_par test_ciba test_session test_rar
VERBOSE=0
MEMCHECK=0
CERT=cert

all: test

clean:
	rm -f *.o $(TARGET) valgrind-*.txt *.log $(CERT)/*.crt $(CERT)/*.key

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

$(CERT)/server.key:
	./$(CERT)/create-cert.sh

%: $(IDDAWC_LIBRARY) %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test_%: % $(IDDAWC_LIBRARY) $(CERT)/server.key
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=$(IDDAWC_LOCATION):${LD_LIBRARY_PATH} ./run_test.sh ./$^; \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=$(IDDAWC_LOCATION):${LD_LIBRARY_PATH} ./$^ ; \
	else \
		CK_FORK=no LD_LIBRARY_PATH=$(IDDAWC_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./$^ 2>valgrind-$@.txt; \
	fi

test: $(TARGET) $(TARGET_TEST)

check: test

=== tools/idwcc/Makefile ===
#
# idwcc: OAuth2/OIDC client program to test or validate OAuth2/OIDC AS
#
# Makefile used to build the software
#
# Copyright 2021 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc
IDDAWC_INCLUDE=../../include
IDDAWC_LOCATION=../../src
DESTDIR=/usr/local
IDDAWC_LIBRARY=../../src/libiddawc.so
IDDAWC_VERSION=$(shell curl -s https://api.github.com/repos/babelouest/iddawc/releases/latest | grep tag_name | cut -d '"' -f 4 | cut -c 2-)
ALPINE_VERSION=3.15.4

CFLAGS+=-c -Wall -Werror -Wconversion -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS) -DWEBAPP_PATH=\"$(DESTDIR)/share/idwcc/webapp/\"
LIBS=-lc -liddawc -L$(IDDAWC_LOCATION) $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs jansson) -lpthread -lz
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes
OBJECTS=idwcc.o static_compressed_inmemory_website_callback.o http_compression_callback.o

all: idwcc

all: ADDITIONALFLAGS= -O3

clean:
	rm -f *.o idwcc
	rm -f iddawc-dev-full_*_alpine_*_x86_64.tar.gz
	docker rmi -f babelouest/idwcc:latest babelouest/idwcc:$(IDDAWC_VERSION)
	docker system prune -f

debug: idwcc

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%.o: %.c $(IDDAWC_LIBRARY) static_compressed_inmemory_website_callback.h static_compressed_inmemory_website_callback.c http_compression_callback.h http_compression_callback.c idwcc.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

idwcc: $(OBJECTS)
	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS)

install: idwcc
	mkdir -p $(DESTDIR)/bin $(DESTDIR)/man/man1/ $(DESTDIR)/share/idwcc/
	install -m755 idwcc $(DESTDIR)/bin
	install -m644 idwcc.1 $(DESTDIR)/man/man1/
	cp -R webapp/ $(DESTDIR)/share/idwcc/

uninstall:
	rm -f $(DESTDIR)/bin/idwcc $(DESTDIR)/man/man1/idwcc.1 $(DESTDIR)/share/idwcc/

test: idwcc
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION): ./idwcc -w webapp

memcheck: debug
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION): $(VALGRIND_COMMAND) ./idwcc -w webapp 2>valgrind.txt

manpage: idwcc
	help2man ./idwcc -s 1 -n "OAuth2/OIDC client program to test or validate OAuth2/OIDC AS." > idwcc.1

iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz:
	wget https://github.com/babelouest/iddawc/releases/download/v${IDDAWC_VERSION}/iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz

docker-build: iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker build -t babelouest/idwcc:$(IDDAWC_VERSION) --build-arg IDDAWC_VERSION=$(IDDAWC_VERSION) --build-arg ALPINE_VERSION=$(ALPINE_VERSION) .
	docker tag babelouest/idwcc:$(IDDAWC_VERSION) babelouest/idwcc:latest

docker-run:
	docker run -it --rm -p 4398:4398 babelouest/idwcc:latest

=== debian/changelog ===
iddawc (1.1.9+ds-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:26:43 +0000

iddawc (1.1.9+ds-2) unstable; urgency=medium

  * d/patches/t64 fix conversion error in tests
  * d/control: Use pkgconf instead of pkg-config
  * d/copyright: Update copyright year to 2024 for debian/* files
  * d/control: Update idwcc package description

 -- Nicolas Mora <babelouest@debian.org>  Fri, 01 Mar 2024 07:52:58 -0500

iddawc (1.1.9+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062345

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:43:10 +0000

iddawc (1.1.9+ds-1) unstable; urgency=medium

  * New upstream release
  * d/watch: Repack to remove duplicate js files (Closes: #1048016)
  * d/rules: Add override_dh_auto_clean
  * d/control: Add node-qrcode-generator in build deps
  * d/libiddawc-dev.install: Add cmake dependencies
  * d/rules: Remove configure option -DDOWNLOAD_DEPENDENCIES=OFF
  * d/rules: Add configure option -DBUILD_IDWCC=ON
  * d/copyright: Add Files-Excluded and remove cmake-modules/DownloadProject/*
  * lintian-overrides: Update ignored warnings
  * d/patches: remove patches

 -- Nicolas Mora <babelouest@debian.org>  Sat, 18 Nov 2023 10:38:09 -0500

=== debian/control ===
Source: iddawc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , librhonabwy-dev
             , libgnutls28-dev
             , libjansson-dev
             , zlib1g-dev
             , cmake
             , pkgconf
             , check
             , doxygen
             , gnutls-bin
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
             , node-qrcode-generator
Standards-Version: 4.6.2
Homepage: https://github.com/babelouest/iddawc
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
Rules-Requires-Root: no

Package: libiddawc1.1t64
Provides: ${t64:Provides}
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libiddawc1.1 (<< ${source:Version}), libiddawc0.9 (<< 0.9.8-2)
Replaces: libiddawc1.1, libiddawc0.9 (<< 0.9.8-2)
Description: OAuth2 and OIDC client library
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values

Package: libiddawc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiddawc1.1t64 (= ${binary:Version}), ${misc:Depends}
       , liborcania-dev
       , libyder-dev
       , libulfius-dev
       , librhonabwy-dev
       , libgnutls28-dev
       , libjansson-dev
       , zlib1g-dev
Description: OAuth2 and OIDC client library - development
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values
 .
 This package contains the development files.

Package: idwcc
Architecture: any
Depends: ${shlibs:Depends}
       , ${misc:Depends}
       , libiddawc1.1t64 (= ${binary:Version})
       , fonts-fork-awesome
       , libjs-jquery
       , libjs-bootstrap4
       , libjs-popper.js
Description: Client for OAuth2/OIDC AS configuration validation
 Provides a web application to be used as an OpenID Connect or OAuth2
 client for local tests or validation.
 .
 Supports PKCE, token introspection, revocation, client registration,
 DPoP, Rich Authorization Request, Pushed Authorization Request,
 JWT Access tokens, encrypted tokens, requests and responses.
 .
 This web application is NOT intended to run in production mode,
 because all the client secrets, keys configuration and metadata are
 fully accessible to the user via the form or the javascript console.
 .
 By default, the application is available to localhost only, for security
 reason.

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, libgnutls28-dev, libjansson-dev, libyder-dev, librhonabwy-dev, liborcania-dev, libulfius-dev, check, libsubunit-dev, pkg-config, gnutls-bin

=== debian/watch ===
version=4

# https://github.com/babelouest/iddawc
opts=\
repacksuffix=+ds,\
repack,compression=xz,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/iddawc-$1/ \
 https://github.com/babelouest/iddawc/tags .*/archive/.*/v?([\d\.]+).tar.gz
